﻿Imports System
Imports System.Collections.Generic

Module Module1
    Sub Main()
        ' Example array to sort
        Dim numbers As Integer() = {34, 7, 23, 32, 5, 62, 32, 34, 35, 8}

        Console.WriteLine("Original Array: " & String.Join(", ", numbers))

        ' Perform QuickSort
        Dim quickSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        QuickSort(quickSortArray, 0, quickSortArray.Length - 1)
        Console.WriteLine("Sorted Array (QuickSort): " & String.Join(", ", quickSortArray))

        ' Perform BubbleSort
        Dim bubbleSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        BubbleSort(bubbleSortArray)
        Console.WriteLine("Sorted Array (BubbleSort): " & String.Join(", ", bubbleSortArray))

        ' Perform MergeSort
        Dim mergeSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        MergeSort(mergeSortArray, 0, mergeSortArray.Length - 1)
        Console.WriteLine("Sorted Array (MergeSort): " & String.Join(", ", mergeSortArray))

        ' Perform InsertionSort
        Dim insertionSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        InsertionSort(insertionSortArray)
        Console.WriteLine("Sorted Array (InsertionSort): " & String.Join(", ", insertionSortArray))

        ' Perform SelectionSort
        Dim selectionSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        SelectionSort(selectionSortArray)
        Console.WriteLine("Sorted Array (SelectionSort): " & String.Join(", ", selectionSortArray))

        ' Perform HeapSort
        Dim heapSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        HeapSort(heapSortArray)
        Console.WriteLine("Sorted Array (HeapSort): " & String.Join(", ", heapSortArray))

        ' Perform RadixSort
        Dim radixSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        RadixSort(radixSortArray)
        Console.WriteLine("Sorted Array (RadixSort): " & String.Join(", ", radixSortArray))

        ' Perform Cocktail Shaker Sort
        Dim cocktailShakerArray As Integer() = DirectCast(numbers.Clone(), Integer())
        CocktailShakerSort(cocktailShakerArray)
        Console.WriteLine("Sorted Array (Cocktail Shaker Sort): " & String.Join(", ", cocktailShakerArray))

        ' Perform Shell Sort
        Dim shellSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        ShellSort(shellSortArray)
        Console.WriteLine("Sorted Array (Shell Sort): " & String.Join(", ", shellSortArray))

        ' Perform Counting Sort
        Dim countingSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        CountingSort(countingSortArray)
        Console.WriteLine("Sorted Array (Counting Sort): " & String.Join(", ", countingSortArray))

        ' Perform Bucket Sort
        Dim bucketSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        BucketSort(bucketSortArray)
        Console.WriteLine("Sorted Array (Bucket Sort): " & String.Join(", ", bucketSortArray))

        ' Perform Timsort
        Dim timSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        TimSort(timSortArray)
        Console.WriteLine("Sorted Array (Timsort): " & String.Join(", ", timSortArray))

        ' Perform N-tree sort
        Dim nTreeSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        NTreeSort(nTreeSortArray)
        Console.WriteLine("Sorted Array (N-Tree Sort): " & String.Join(", ", nTreeSortArray))

        ' Perform Comb Sort
        Dim combSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        CombSort(combSortArray)
        Console.WriteLine("Sorted Array (Comb Sort): " & String.Join(", ", combSortArray))

        ' Perform Odd-Even Sort
        Dim oddEvenSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        OddEvenSort(oddEvenSortArray)
        Console.WriteLine("Sorted Array (Odd-Even Sort): " & String.Join(", ", oddEvenSortArray))

        ' Perform Gnome Sort
        Dim gnomeSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        GnomeSort(gnomeSortArray)
        Console.WriteLine("Sorted Array (Gnome Sort): " & String.Join(", ", gnomeSortArray))

        ' Perform Pigeonhole Sort
        Dim pigeonholeSortArray As Integer() = DirectCast(numbers.Clone(), Integer())
        PigeonholeSort(pigeonholeSortArray)
        Console.WriteLine("Sorted Array (Pigeonhole Sort): " & String.Join(", ", pigeonholeSortArray))

        Console.ReadLine()

    End Sub

    ' QuickSort Function
    Sub QuickSort(arr As Integer(), left As Integer, right As Integer)
        If left < right Then
            Dim pivotIndex As Integer = Partition(arr, left, right)
            QuickSort(arr, left, pivotIndex - 1)
            QuickSort(arr, pivotIndex + 1, right)
        End If
    End Sub

    ' Partitioning Function for QuickSort
    Function Partition(arr As Integer(), left As Integer, right As Integer) As Integer
        Dim pivot As Integer = arr(right)
        Dim i As Integer = left - 1

        For j As Integer = left To right - 1
            If arr(j) <= pivot Then
                i += 1
                Swap(arr, i, j)
            End If
        Next

        Swap(arr, i + 1, right)
        Return i + 1
    End Function

    ' Swap Function
    Sub Swap(arr As Integer(), i As Integer, j As Integer)
        Dim temp As Integer = arr(i)
        arr(i) = arr(j)
        arr(j) = temp
    End Sub

    ' BubbleSort Function
    Sub BubbleSort(arr As Integer())
        Dim n As Integer = arr.Length
        Dim swapped As Boolean

        For i As Integer = 0 To n - 1
            swapped = False
            For j As Integer = 0 To n - 2 - i
                If arr(j) > arr(j + 1) Then
                    Swap(arr, j, j + 1)
                    swapped = True
                End If
            Next

            If Not swapped Then
                Exit For
            End If
        Next
    End Sub

    ' MergeSort Function
    Sub MergeSort(arr As Integer(), left As Integer, right As Integer)
        If left < right Then
            Dim middle As Integer = (left + right) \ 2
            MergeSort(arr, left, middle)
            MergeSort(arr, middle + 1, right)
            Merge(arr, left, middle, right)
        End If
    End Sub

    ' Merge Function
    Sub Merge(arr As Integer(), left As Integer, middle As Integer, right As Integer)
        Dim n1 As Integer = middle - left + 1
        Dim n2 As Integer = right - middle

        Dim L(n1 - 1) As Integer
        Dim R(n2 - 1) As Integer

        Array.Copy(arr, left, L, 0, n1)
        Array.Copy(arr, middle + 1, R, 0, n2)

        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim k As Integer = left

        While i < n1 AndAlso j < n2
            If L(i) <= R(j) Then
                arr(k) = L(i)
                i += 1
            Else
                arr(k) = R(j)
                j += 1
            End If
            k += 1
        End While

        While i < n1
            arr(k) = L(i)
            i += 1
            k += 1
        End While

        While j < n2
            arr(k) = R(j)
            j += 1
            k += 1
        End While
    End Sub

    ' InsertionSort Function
    Sub InsertionSort(arr As Integer())
        Dim n As Integer = arr.Length
        For i As Integer = 1 To n - 1
            Dim key As Integer = arr(i)
            Dim j As Integer = i - 1

            While j >= 0 AndAlso arr(j) > key
                arr(j + 1) = arr(j)
                j -= 1
            End While
            arr(j + 1) = key
        Next
    End Sub

    ' SelectionSort Function
    Sub SelectionSort(arr As Integer())
        Dim n As Integer = arr.Length

        For i As Integer = 0 To n - 2
            Dim minIndex As Integer = i
            For j As Integer = i + 1 To n - 1
                If arr(j) < arr(minIndex) Then
                    minIndex = j
                End If
            Next

            If minIndex <> i Then
                Swap(arr, i, minIndex)
            End If
        Next
    End Sub

    ' HeapSort Function
    Sub HeapSort(arr As Integer())
        Dim n As Integer = arr.Length

        For i As Integer = n \ 2 - 1 To 0 Step -1
            Heapify(arr, n, i)
        Next

        For i As Integer = n - 1 To 1 Step -1
            Swap(arr, 0, i)
            Heapify(arr, i, 0)
        Next
    End Sub

    ' To heapify a subtree rooted with node i
    Sub Heapify(arr As Integer(), n As Integer, i As Integer)
        Dim largest As Integer = i
        Dim left As Integer = 2 * i + 1
        Dim right As Integer = 2 * i + 2

        If left < n AndAlso arr(left) > arr(largest) Then
            largest = left
        End If

        If right < n AndAlso arr(right) > arr(largest) Then
            largest = right
        End If

        If largest <> i Then
            Swap(arr, i, largest)
            Heapify(arr, n, largest)
        End If
    End Sub

    ' RadixSort Function
    Sub RadixSort(arr As Integer())
        Dim max As Integer = arr.Max()
        Dim exp As Integer = 1
        While max / exp > 1
            CountingSort(arr, exp)
            exp *= 10
        End While
    End Sub

    ' CountingSort for RadixSort
    Sub CountingSort(arr As Integer(), exp As Integer)
        Dim n As Integer = arr.Length
        Dim output(n - 1) As Integer
        Dim count(9) As Integer

        For i As Integer = 0 To 9
            count(i) = 0
        Next

        For i As Integer = 0 To n - 1
            count((arr(i) \ exp) Mod 10) += 1
        Next

        For i As Integer = 1 To 9
            count(i) += count(i - 1)
        Next

        For i As Integer = n - 1 To 0 Step -1
            output(count((arr(i) \ exp) Mod 10) - 1) = arr(i)
            count((arr(i) \ exp) Mod 10) -= 1
        Next

        Array.Copy(output, arr, n)
    End Sub

    ' Cocktail Shaker Sort Function
    Sub CocktailShakerSort(arr As Integer())
        Dim n As Integer = arr.Length
        Dim swapped As Boolean = True
        Dim start As Integer = 0
        Dim end2 As Integer = n - 1

        While swapped
            swapped = False

            For i As Integer = start To end2 - 1
                If arr(i) > arr(i + 1) Then
                    Swap(arr, i, i + 1)
                    swapped = True
                End If
            Next

            If Not swapped Then
                Exit Sub
            End If

            swapped = False
            end2 -= 1

            For i As Integer = end2 To start Step -1
                If arr(i) > arr(i + 1) Then
                    Swap(arr, i, i + 1)
                    swapped = True
                End If
            Next

            start += 1
        End While
    End Sub

    ' Shell Sort Function
    Sub ShellSort(arr As Integer())
        Dim n As Integer = arr.Length
        Dim gap As Integer = n \ 2

        While gap > 0
            For i As Integer = gap To n - 1
                Dim temp As Integer = arr(i)
                Dim j As Integer = i

                While j >= gap AndAlso arr(j - gap) > temp
                    arr(j) = arr(j - gap)
                    j -= gap
                End While

                arr(j) = temp
            Next
            gap \= 2
        End While
    End Sub

    ' Counting Sort Function
    Sub CountingSort(arr As Integer())
        Dim n As Integer = arr.Length
        If n = 0 Then Return

        Dim max As Integer = arr.Max()
        Dim count(max) As Integer
        Dim output(n - 1) As Integer

        For i As Integer = 0 To max
            count(i) = 0
        Next

        For i As Integer = 0 To n - 1
            count(arr(i)) += 1
        Next

        For i As Integer = 1 To max
            count(i) += count(i - 1)
        Next

        For i As Integer = n - 1 To 0 Step -1
            output(count(arr(i)) - 1) = arr(i)
            count(arr(i)) -= 1
        Next

        Array.Copy(output, arr, n)
    End Sub

    ' Bucket Sort Function
    Sub BucketSort(arr As Integer())
        Dim n As Integer = arr.Length
        If n <= 0 Then Return

        Dim bucket As New List(Of List(Of Integer))()
        For i As Integer = 0 To n - 1
            bucket.Add(New List(Of Integer)())
        Next

        For i As Integer = 0 To n - 1
            Dim index As Integer = arr(i) \ (n + 1)
            bucket(index).Add(arr(i))
        Next

        Dim sorted As New List(Of Integer)()
        For i As Integer = 0 To n - 1
            If bucket(i).Count > 0 Then
                Dim bucketArray As Integer() = bucket(i).ToArray()
                Array.Sort(bucketArray)
                sorted.AddRange(bucketArray)
            End If
        Next

        Array.Copy(sorted.ToArray(), arr, sorted.Count)
    End Sub

    ' Timsort Function
    Sub TimSort(arr As Integer())
        Dim n As Integer = arr.Length
        Dim minRun As Integer = 32

        For start As Integer = 0 To n - 1 Step minRun
            Dim endRun As Integer = Math.Min(start + minRun - 1, n - 1)
            InsertionSort(arr, start, endRun)
        Next

        Dim size As Integer = minRun
        While size < n
            For left As Integer = 0 To n - 1 Step 2 * size
                Dim mid As Integer = Math.Min(left + size - 1, n - 1)
                Dim right As Integer = Math.Min((left + 2 * size - 1), (n - 1))

                If mid < right Then
                    Merge(arr, left, mid, right)
                End If
            Next
            size *= 2
        End While
    End Sub

    ' Insertion Sort for Timsort
    Sub InsertionSort(arr As Integer(), left As Integer, right As Integer)
        For i As Integer = left + 1 To right
            Dim key As Integer = arr(i)
            Dim j As Integer = i - 1
            While j >= left AndAlso arr(j) > key
                arr(j + 1) = arr(j)
                j -= 1
            End While
            arr(j + 1) = key
        Next
    End Sub

    ' Define Node class
    Public Class TreeNode
        Public Property Value As Integer
        Public Property Left As TreeNode
        Public Property Right As TreeNode

        Public Sub New(value As Integer)
            Me.Value = value
            Left = Nothing
            Right = Nothing
        End Sub
    End Class

    ' Insert Method
    Sub InsertNode(ByRef root As TreeNode, value As Integer)
        If root Is Nothing Then
            root = New TreeNode(value)
        ElseIf value < root.Value Then
            InsertNode(root.Left, value)
        Else
            InsertNode(root.Right, value)
        End If
    End Sub

    ' In-Order Traversal
    Sub InOrderTraversal(node As TreeNode, arr As List(Of Integer))
        If node IsNot Nothing Then
            InOrderTraversal(node.Left, arr)
            arr.Add(node.Value)
            InOrderTraversal(node.Right, arr)
        End If
    End Sub

    ' N-Tree Sort
    Sub NTreeSort(arr As Integer())
        Dim root As TreeNode = Nothing

        ' Insert elements into the tree
        For Each value As Integer In arr
            InsertNode(root, value)
        Next

        ' In-order traversal to get sorted elements
        Dim sortedList As New List(Of Integer)()
        InOrderTraversal(root, sortedList)

        ' Copy sorted elements back to original array
        For i As Integer = 0 To sortedList.Count - 1
            arr(i) = sortedList(i)
        Next
    End Sub

    Sub CombSort(arr As Integer())
        Dim gap As Integer = arr.Length
        Dim shrink As Double = 1.3
        Dim sorted As Boolean = False

        While gap > 1 OrElse Not sorted
            ' Update the gap value for this iteration
            gap = CInt(Math.Floor(gap / shrink))
            If gap < 1 Then
                gap = 1
            End If

            sorted = True  ' Assume it's sorted until a swap happens

            ' Compare elements at the gap distance
            For i As Integer = 0 To arr.Length - gap - 1
                If arr(i) > arr(i + gap) Then
                    ' Swap if elements are in the wrong order
                    Swap2(arr, i, i + gap)
                    sorted = False  ' We made a swap, so it wasn't sorted
                End If
            Next
        End While
    End Sub

    Sub Swap2(arr As Integer(), indexA As Integer, indexB As Integer)
        Dim temp As Integer = arr(indexA)
        arr(indexA) = arr(indexB)
        arr(indexB) = temp
    End Sub

    ' Odd-Even Sort Function
    Sub OddEvenSort(arr As Integer())
        Dim n As Integer = arr.Length
        Dim sorted As Boolean = False

        While Not sorted
            sorted = True

            ' Perform the odd indexed phase
            For i As Integer = 1 To n - 2 Step 2
                If arr(i) > arr(i + 1) Then
                    Swap2(arr, i, i + 1)
                    sorted = False
                End If
            Next

            ' Perform the even indexed phase
            For i As Integer = 0 To n - 2 Step 2
                If arr(i) > arr(i + 1) Then
                    Swap2(arr, i, i + 1)
                    sorted = False
                End If
            Next
        End While
    End Sub

    ' Gnome Sort Function
    Sub GnomeSort(arr As Integer())
        Dim i As Integer = 0
        Dim n As Integer = arr.Length

        While i < n
            If i = 0 Then
                i += 1
            End If

            If arr(i) >= arr(i - 1) Then
                i += 1
            Else
                Swap(arr, i, i - 1)
                i -= 1
            End If
        End While
    End Sub

    Sub PigeonholeSort(arr As Integer())
        Dim min As Integer = arr.Min()
        Dim max As Integer = arr.Max()

        Dim range As Integer = max - min + 1
        Dim holes(range - 1) As Integer

        ' Initialize the empty holes
        For i As Integer = 0 To range - 1
            holes(i) = 0
        Next

        ' Store the count of each element in the corresponding hole
        For i As Integer = 0 To arr.Length - 1
            holes(arr(i) - min) += 1
        Next

        Dim index As Integer = 0
        For i As Integer = 0 To range - 1
            While holes(i) > 0
                arr(index) = i + min
                index += 1
                holes(i) -= 1
            End While
        Next
    End Sub

End Module
